from math import floor, sqrt, ceil

# ogni numero non puo' avere piu' di un divisore grande quanto la sua radice
# per cui posso cercare un divisore fino alla radice quadrata del numero
#
# NOTA: devo usare ceil() e la radice deve essere calcolata per n+1
# (si pensi al quadrato perfetto 25...)

def primo(n):
	"""Restituisce True se il numero e` primo, False altrimenti"""

	for i in range(2, ceil(sqrt(n + 1))):
		if n % i == 0:
			return False

	return True

def numeriprimi(n):
	"""Restituisce una lista di interi che contiene i numeri primi minori
	   del numero n passato in ingresso
	"""
	primi = []
	# n + 1 
	for i in range(2, n + 1):
		if primo(i):
			primi.append(i)
	
	return primi

def scomponi(n):
	"""Scompone il numero n in fattori primi, che sono restituiti in una lista"""
	fattprimi = numeriprimi(n)
#
# 	Alcune print qua e la` aiutano a capire cosa succede nel programma se abbiamo dubbi...
#
#	print("Possibili fattori primi di ", n, ":", fattprimi)

	fatt = []
	
	q = n

	i = 0

	while q > 1:
		if q % fattprimi[i] == 0: # q divisibile per fattore primo in posizione i
			q = q / fattprimi[i] # divido
			fatt.append(fattprimi[i])
		else:
			i = i + 1
#		print("q", q, "i", i)	
	
	return fatt

